#include "xbp.ch"
#include "dll.ch"

DLLFUNCTION GetDC( nHWND ) USING STDCALL FROM USER32.DLL
DLLFUNCTION ReleaseDC( nHWND, nHDC ) USING STDCALL FROM USER32.DLL
DLLFUNCTION GetDeviceCaps( nHWND, nIndex ) USING STDCALL FROM GDI32.DLL

// Pixels per inch if small or large font is active
#define SMALLFONT 96
#define LARGEFONT 120

// DeviceCap ID to retrieve device pix/inch attribute
#define LOGPIXELSX     88
#define LOGPIXELSY     90

PROCEDURE main
  ? "Desktop has (",GetDesktopDPI(),") dpi"
  WAIT
RETURN

FUNCTION GetDesktopDPI()

  LOCAL oDesktop, hWND, hDC, nLogPixX

  IF AppType() != APPTYPE_PM
    ? "Application not linked GUI"
    wait
    QUIT
  ENDIF

  oDesktop := AppDesktop()

  hWND := oDesktop:GetHWND()
  hDC   := GetDC(hWND)
  IF(hDC==-1)
    // could not aquire device
    RETURN(NIL)
  ENDIF

  nLogPixX := GetDeviceCaps(hDC,LOGPIXELSX)

  ReleaseDC(hWND,hDC)

RETURN(nLogPixX)